//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System.Linq;
using Tecan.Sila2;
using Tecan.Sila2.Client;
using Tecan.Sila2.Server;

namespace Tecan.Sila2.Generator.Test.TestReference
{
    
    
    /// <summary>
    /// A class that exposes the ISiLAService interface via SiLA2
    /// </summary>
    [System.ComponentModel.Composition.ExportAttribute(typeof(IFeatureProvider))]
    [System.ComponentModel.Composition.PartCreationPolicyAttribute(System.ComponentModel.Composition.CreationPolicy.Shared)]
    public partial class SiLAServiceProvider : IFeatureProvider
    {
        
        private ISiLAService _implementation;
        
        private Tecan.Sila2.Server.ISiLAServer _server;
        
        private static Tecan.Sila2.Feature _feature = FeatureSerializer.LoadFromAssembly(typeof(SiLAServiceProvider).Assembly, "SiLAService.sila.xml");
        
        /// <summary>
        /// Creates a new instance
        /// </summary>
        /// <param name="implementation">The implementation to exported through SiLA2</param>
        /// <param name="server">The SiLA2 server instance through which the implementation shall be exported</param>
        [System.ComponentModel.Composition.ImportingConstructorAttribute()]
        public SiLAServiceProvider(ISiLAService implementation, Tecan.Sila2.Server.ISiLAServer server)
        {
            _implementation = implementation;
            _server = server;
        }
        
        /// <summary>
        /// The feature that is exposed by this feature provider
        /// </summary>
        /// <returns>A feature object</returns>
        public Tecan.Sila2.Feature FeatureDefinition
        {
            get
            {
                return _feature;
            }
        }
        
        /// <summary>
        /// Registers the feature in the provided feature registration
        /// </summary>
        /// <param name="registration">The registration component to which the feature should be registered</param>
        public void Register(IServerBuilder registration)
        {
            registration.RegisterUnobservableCommand<GetFeatureDefinitionRequestDto, GetFeatureDefinitionResponseDto>("GetFeatureDefinition", GetFeatureDefinition);
            registration.RegisterUnobservableCommand<SetServerNameRequestDto, EmptyRequest>("SetServerName", SetServerName);
            registration.RegisterUnobservableProperty("ServerName", GetServerName);
            registration.RegisterUnobservableProperty("ServerType", GetServerType);
            registration.RegisterUnobservableProperty("ServerUUID", GetServerUUID);
            registration.RegisterUnobservableProperty("ServerDescription", GetServerDescription);
            registration.RegisterUnobservableProperty("ServerVersion", GetServerVersion);
            registration.RegisterUnobservableProperty("ServerVendorURL", GetServerVendorURL);
            registration.RegisterUnobservableProperty("ImplementedFeatures", GetImplementedFeatures);
        }
        
        /// <summary>
        /// Executes the Get Feature Definition command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual GetFeatureDefinitionResponseDto GetFeatureDefinition(GetFeatureDefinitionRequestDto request)
        {
            try
            {
                request.Validate();
                return new GetFeatureDefinitionResponseDto(_implementation.GetFeatureDefinition(request.QualifiedFeatureIdentifier.TryExtract(_server, "tecan.sila.generator.test/silaservice/SiLAService/v4/Command/GetFeatureDefinition" +
                                "/Parameter/QualifiedFeatureIdentifier")), _server);
            } catch (System.ArgumentException ex)
            {
                if ((ex.ParamName == "qualifiedFeatureIdentifier"))
                {
                    throw _server.ErrorHandling.CreateValidationError("tecan.sila.generator.test/silaservice/SiLAService/v4/Command/GetFeatureDefinition" +
                            "/Parameter/QualifiedFeatureIdentifier", ex.Message);
                }
                throw _server.ErrorHandling.CreateUnknownValidationError(ex);
            } catch (UnimplementedFeatureException ex)
            {
                throw _server.ErrorHandling.CreateExecutionError("tecan.sila.generator.test/silaservice/SiLAService/v4/DefinedExecutionError/Unimpl" +
                        "ementedFeature", "The feature specified by the given feature identifier is not implemented by the s" +
                        "erver.", ex.Message);
            }
        }
        
        /// <summary>
        /// Executes the Set Server Name command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual EmptyRequest SetServerName(SetServerNameRequestDto request)
        {
            try
            {
                request.Validate();
                _implementation.ServerName = request.ServerName.TryExtract(_server, "tecan.sila.generator.test/silaservice/SiLAService/v4/Command/SetServerName/Parame" +
                        "ter/ServerName");
                return EmptyRequest.Instance;
            } catch (System.ArgumentException ex)
            {
                if ((ex.ParamName == "serverName"))
                {
                    throw _server.ErrorHandling.CreateValidationError("tecan.sila.generator.test/silaservice/SiLAService/v4/Command/SetServerName/Parame" +
                            "ter/ServerName", ex.Message);
                }
                throw _server.ErrorHandling.CreateUnknownValidationError(ex);
            }
        }
        
        /// <summary>
        /// Gets the current value of the Server Name property
        /// </summary>
        /// <returns>The current value wrapped in a data transfer object</returns>
        protected virtual PropertyResponse<Tecan.Sila2.StringDto> GetServerName()
        {
            return new PropertyResponse<Tecan.Sila2.StringDto>(new Tecan.Sila2.StringDto(_implementation.ServerName, _server));
        }
        
        /// <summary>
        /// Gets the current value of the Server Type property
        /// </summary>
        /// <returns>The current value wrapped in a data transfer object</returns>
        protected virtual PropertyResponse<Tecan.Sila2.StringDto> GetServerType()
        {
            return new PropertyResponse<Tecan.Sila2.StringDto>(new Tecan.Sila2.StringDto(_implementation.ServerType, _server));
        }
        
        /// <summary>
        /// Gets the current value of the Server UUID property
        /// </summary>
        /// <returns>The current value wrapped in a data transfer object</returns>
        protected virtual ServerUUIDResponseDto GetServerUUID()
        {
            return new ServerUUIDResponseDto(_implementation.ServerUUID, _server);
        }
        
        /// <summary>
        /// Gets the current value of the Server Description property
        /// </summary>
        /// <returns>The current value wrapped in a data transfer object</returns>
        protected virtual PropertyResponse<Tecan.Sila2.StringDto> GetServerDescription()
        {
            return new PropertyResponse<Tecan.Sila2.StringDto>(new Tecan.Sila2.StringDto(_implementation.ServerDescription, _server));
        }
        
        /// <summary>
        /// Gets the current value of the Server Version property
        /// </summary>
        /// <returns>The current value wrapped in a data transfer object</returns>
        protected virtual ServerVersionResponseDto GetServerVersion()
        {
            return new ServerVersionResponseDto(_implementation.ServerVersion, _server);
        }
        
        /// <summary>
        /// Gets the current value of the Server Vendor URL property
        /// </summary>
        /// <returns>The current value wrapped in a data transfer object</returns>
        protected virtual PropertyResponse<UrlDto> GetServerVendorURL()
        {
            return new PropertyResponse<UrlDto>(new UrlDto(_implementation.ServerVendorURL, _server));
        }
        
        /// <summary>
        /// Gets the current value of the Implemented Features property
        /// </summary>
        /// <returns>The current value wrapped in a data transfer object</returns>
        protected virtual PropertyResponse<System.Collections.Generic.List<FeatureIdentifierDto>> GetImplementedFeatures()
        {
            return new PropertyResponse<System.Collections.Generic.List<FeatureIdentifierDto>>(Tecan.Sila2.DtoExtensions.Encapsulate(_implementation.ImplementedFeatures, FeatureIdentifierDto.Create, _server));
        }
        
        /// <summary>
        /// Gets the command with the given identifier
        /// </summary>
        /// <param name="commandIdentifier">A fully qualified command identifier</param>
        /// <returns>A method object or null, if the command is not supported</returns>
        public System.Reflection.MethodInfo GetCommand(string commandIdentifier)
        {
            if ((commandIdentifier == "tecan.sila.generator.test/silaservice/SiLAService/v4/Command/GetFeatureDefinition" +
                ""))
            {
                return typeof(ISiLAService).GetMethod("GetFeatureDefinition");
            }
            if ((commandIdentifier == "tecan.sila.generator.test/silaservice/SiLAService/v4/Command/SetServerName"))
            {
                return typeof(ISiLAService).GetMethod("SetServerName");
            }
            return null;
        }
        
        /// <summary>
        /// Gets the property with the given identifier
        /// </summary>
        /// <param name="propertyIdentifier">A fully qualified property identifier</param>
        /// <returns>A property object or null, if the property is not supported</returns>
        public System.Reflection.PropertyInfo GetProperty(string propertyIdentifier)
        {
            if ((propertyIdentifier == "tecan.sila.generator.test/silaservice/SiLAService/v4/Property/ServerName"))
            {
                return typeof(ISiLAService).GetProperty("ServerName");
            }
            if ((propertyIdentifier == "tecan.sila.generator.test/silaservice/SiLAService/v4/Property/ServerType"))
            {
                return typeof(ISiLAService).GetProperty("ServerType");
            }
            if ((propertyIdentifier == "tecan.sila.generator.test/silaservice/SiLAService/v4/Property/ServerUUID"))
            {
                return typeof(ISiLAService).GetProperty("ServerUUID");
            }
            if ((propertyIdentifier == "tecan.sila.generator.test/silaservice/SiLAService/v4/Property/ServerDescription"))
            {
                return typeof(ISiLAService).GetProperty("ServerDescription");
            }
            if ((propertyIdentifier == "tecan.sila.generator.test/silaservice/SiLAService/v4/Property/ServerVersion"))
            {
                return typeof(ISiLAService).GetProperty("ServerVersion");
            }
            if ((propertyIdentifier == "tecan.sila.generator.test/silaservice/SiLAService/v4/Property/ServerVendorURL"))
            {
                return typeof(ISiLAService).GetProperty("ServerVendorURL");
            }
            if ((propertyIdentifier == "tecan.sila.generator.test/silaservice/SiLAService/v4/Property/ImplementedFeatures" +
                ""))
            {
                return typeof(ISiLAService).GetProperty("ImplementedFeatures");
            }
            return null;
        }
    }
}

